com.threerings.parlor.data

## Class ParlorMarshaller

- java.lang.Object
- - com.threerings.presents.data.InvocationMarshaller
  - - com.threerings.parlor.data.ParlorMarshaller

All Implemented Interfaces:
  com.threerings.io.Streamable, ParlorService, com.threerings.presents.client.InvocationService

    @Generated(value="com.threerings.presents.tools.GenServiceTask",
               comments="Derived from ParlorService.java.")
    public class ParlorMarshaller
    extends com.threerings.presents.data.InvocationMarshaller
    implements ParlorService

Provides the implementation of the `ParlorService` interface that marshalls the arguments and delivers the request to the provider on the server. Also provides an implementation of the response listener interfaces that marshall the response arguments and deliver them back to the requesting client.

### Nested Class Summary

Nested Classes
`static class` `ParlorMarshaller.InviteMarshaller` Marshalls results to implementations of `ParlorService.InviteListener`.

### Nested classes/interfaces inherited from class com.threerings.presents.data.InvocationMarshaller

`com.threerings.presents.data.InvocationMarshaller.ConfirmMarshaller, com.threerings.presents.data.InvocationMarshaller.ListenerMarshaller, com.threerings.presents.data.InvocationMarshaller.ResultMarshaller`

### Nested classes/interfaces inherited from interface com.threerings.parlor.client.ParlorService

`ParlorService.InviteListener`

### Nested classes/interfaces inherited from interface com.threerings.presents.client.InvocationService

`com.threerings.presents.client.InvocationService.ConfirmListener, com.threerings.presents.client.InvocationService.InvocationListener, com.threerings.presents.client.InvocationService.ResultListener`

### Nested classes/interfaces inherited from interface com.threerings.io.Streamable

`com.threerings.io.Streamable.Closure`

### Field Summary

Fields
`static int` `CANCEL` The method id used to dispatch `cancel(int, com.threerings.presents.client.InvocationService.InvocationListener)` requests.
`static int` `INVITE` The method id used to dispatch `invite(com.threerings.util.Name, com.threerings.parlor.game.data.GameConfig, com.threerings.parlor.client.ParlorService.InviteListener)` requests.
`static int` `RESPOND` The method id used to dispatch `respond(int, int, java.lang.Object, com.threerings.presents.client.InvocationService.InvocationListener)` requests.
`static int` `START_SOLITAIRE` The method id used to dispatch `startSolitaire(com.threerings.parlor.game.data.GameConfig, com.threerings.presents.client.InvocationService.ConfirmListener)` requests.

### Constructor Summary

Constructors
Constructor and Description
`ParlorMarshaller()`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `cancel(int arg1, com.threerings.presents.client.InvocationService.InvocationListener arg2)` You probably don't want to call this directly, but want to call `Invitation.cancel()`.
`void` `invite(com.threerings.util.Name arg1, GameConfig arg2, ParlorService.InviteListener arg3)` You probably don't want to call this directly, but want to generate your invitation request via `ParlorDirector.invite(com.threerings.util.Name, com.threerings.parlor.game.data.GameConfig, com.threerings.parlor.client.InvitationResponseObserver)`.
`void` `respond(int arg1, int arg2, Object arg3, com.threerings.presents.client.InvocationService.InvocationListener arg4)` You probably don't want to call this directly, but want to call one of `Invitation.accept()`, `Invitation.refuse(java.lang.String)`, or `Invitation.counter(com.threerings.parlor.game.data.GameConfig, com.threerings.parlor.client.InvitationResponseObserver)`.
`void` `startSolitaire(GameConfig arg1, com.threerings.presents.client.InvocationService.ConfirmListener arg2)` Requests to start a single player game with the specified game configuration.

### Methods inherited from class com.threerings.presents.data.InvocationMarshaller

`getInvocationCode, init, readObject, setInvocationOid, setNoResponse, toString`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### CANCEL

    public static final int CANCEL

The method id used to dispatch `cancel(int, com.threerings.presents.client.InvocationService.InvocationListener)` requests.

See Also:
  Constant Field Values

#### INVITE

    public static final int INVITE

The method id used to dispatch `invite(com.threerings.util.Name, com.threerings.parlor.game.data.GameConfig, com.threerings.parlor.client.ParlorService.InviteListener)` requests.

See Also:
  Constant Field Values

#### RESPOND

    public static final int RESPOND

The method id used to dispatch `respond(int, int, java.lang.Object, com.threerings.presents.client.InvocationService.InvocationListener)` requests.

See Also:
  Constant Field Values

#### START_SOLITAIRE

    public static final int START_SOLITAIRE

The method id used to dispatch `startSolitaire(com.threerings.parlor.game.data.GameConfig, com.threerings.presents.client.InvocationService.ConfirmListener)` requests.

See Also:
  Constant Field Values

### Constructor Detail

#### ParlorMarshaller

    public ParlorMarshaller()

### Method Detail

#### cancel

    public void cancel(int arg1,
                       com.threerings.presents.client.InvocationService.InvocationListener arg2)

Description copied from interface: `ParlorService`
You probably don't want to call this directly, but want to call `Invitation.cancel()`. Requests that an outstanding invitation be cancelled.

Specified by:
  `cancel` in interface `ParlorService`
Parameters:
  `arg1` - the unique id previously assigned by the server to this invitation.
  `arg2` - will receive and process the response.

#### invite

    public void invite(com.threerings.util.Name arg1,
                       GameConfig arg2,
                       ParlorService.InviteListener arg3)

Description copied from interface: `ParlorService`
You probably don't want to call this directly, but want to generate your invitation request via `ParlorDirector.invite(com.threerings.util.Name, com.threerings.parlor.game.data.GameConfig, com.threerings.parlor.client.InvitationResponseObserver)`. Requests that an invitation be delivered to the named user, requesting that they join the inviting user in a game, the details of which are specified in the supplied game config object.

Specified by:
  `invite` in interface `ParlorService`
Parameters:
  `arg1` - the username of the user to be invited.
  `arg2` - a game config object detailing the type and configuration of the game to be created.
  `arg3` - will receive and process the response.

#### respond

    public void respond(int arg1,
                        int arg2,
                        Object arg3,
                        com.threerings.presents.client.InvocationService.InvocationListener arg4)

Description copied from interface: `ParlorService`
You probably don't want to call this directly, but want to call one of `Invitation.accept()`, `Invitation.refuse(java.lang.String)`, or `Invitation.counter(com.threerings.parlor.game.data.GameConfig, com.threerings.parlor.client.InvitationResponseObserver)`. Requests that an invitation response be delivered with the specified parameters.

Specified by:
  `respond` in interface `ParlorService`
Parameters:
  `arg1` - the unique id previously assigned by the server to this invitation.
  `arg2` - the response code to use in responding to the invitation.
  `arg3` - the argument associated with the response (a string message from the player explaining why the response was refused in the case of an invitation refusal or an updated game configuration object in the case of a counter-invitation, or null in the case of an accepted invitation).
  `arg4` - will receive and process the response.

#### startSolitaire

    public void startSolitaire(GameConfig arg1,
                               com.threerings.presents.client.InvocationService.ConfirmListener arg2)

Description copied from interface: `ParlorService`
Requests to start a single player game with the specified game configuration.

Specified by:
  `startSolitaire` in interface `ParlorService`